<template>
  <q-card class="my-card w-300" @mouseover="showActions = true" @mouseleave="showActions = false">
    <q-card-section>
      <div class="flex justify-between">
        <div class="items-start">
          <div class="text-h6">{{ note.ShortestContent ? note.ShortestContent.title : '' }}</div>
        </div>
        <div>
          <q-btn @click.prevent.stop="pinStatus()" flat>
            <q-icon name="push_pin" :color="note.has_pin === 0 ? 'grey-5' : ''"/>
          </q-btn>
        </div>
      </div>
    </q-card-section>
    <q-card-section>
      <div class="text-h7" style="white-space: pre-wrap">
        {{note.ShortestContent ? note.ShortestContent.content : ''}}
      </div>
    </q-card-section>

    <q-card-actions align="around">
      <q-btn @click.prevent.stop="deleteNote(note.id)" flat>
        <q-tooltip class="f-12">Eliminar</q-tooltip>

        <q-icon name="delete" color="grey-5"/>
      </q-btn>
      <q-btn @click.prevent.stop="archiveNotes(note.id)" flat>
        <q-tooltip v-if="note.is_archived == 0" class="f-12">Archivar</q-tooltip>
        <q-tooltip v-else class="f-12">Eliminar del archivo</q-tooltip>

        <q-icon name="move_to_inbox" :color="note.is_archived === 0 ? 'grey-5' : ''"/>
      </q-btn>
    </q-card-actions>
  </q-card>
</template>

<script>
import axios from "axios";
import {apiUrl} from "src/config";

export default {
  name: "CardShowNote",
  props: {
    data: {
      type: Object,
    }
  },
  data() {
    return {
      note: {},
      apiUrl: apiUrl,
      showActions:false,
    }
  },
  methods: {
    archiveNotes() {
      this.note.is_archived = this.note.is_archived === 1 ? 0 : 1;
      this.note.has_pin = 0;
      axios({
        method: 'post',
        url: `${this.apiUrl}notes/${this.note.id}/archive`,
        data: this.note
      })
        .then(res => {
          this.$emit('update')
        }).catch(err => {
        console.error(err);
      })
    },
    pinStatus() {
      this.note.has_pin = this.note.has_pin === 1 ? 0 : 1;
      this.note.is_archived = 0;
      axios(
        {
          method: 'put',
          url: `${this.apiUrl}notes/${this.note.id}`,
          data: this.note
        }
      ).then(res => {
        this.$emit('update')
      }).catch(err => {
        console.error(err);
      })
    },
    deleteNote(id) {
      axios.delete(`${this.apiUrl}notes/${id}`)
        .then(res => {
          this.$emit('update')
        })
        .catch(err => {
          console.log(err)
        })
    },
  },
  mounted() {
    this.note = {...this.data};
  }
}
</script>

<style scoped>
.my-card .text-h7 {
  overflow-wrap: break-word;
}
</style>
